@ECHO OFF
SETLOCAL EnableDelayedExpansion
TITLE %0

SET _OUTFOLDER=orin
SET _BSPZIP="K:\SteamLibrary\steamapps\common\Team Fortress 2\bin\bspzip.exe"
SET _VBSPINFO="K:\SteamLibrary\steamapps\common\Team Fortress 2\bin\vbspinfo.exe"

REM Folders can't be generated so we need to do it ourselves. Format: K:Path\%_OUTFOLDER%
REM - "dp" means "Drive Path".
SET _destfolder="%~0\..\%_OUTFOLDER%"
IF NOT EXIST %_destfolder% (
	MD %_destfolder%
)

REM BAT filename as header for both CMD prompt and generated TXT.
SET "_header=------------ orin_entlmp.bat ------------"
ECHO %_header%
ECHO/

REM Verify that the paths to valve programs we need are set correctly.
IF NOT EXIST %_BSPZIP% (
	ECHO HOLD ON THERE. I CAN'T FIND bin\bspzip.exe. Plz edit the batch file and put in the correct paths for me.
	pause
	goto :EOF
)
IF NOT EXIST %_VBSPINFO% (
	ECHO HOLD ON THERE. I CAN'T FIND bin\vbspinfo.exe. Plz edit the batch file and put in the correct paths for me.
	pause
	goto :EOF
)

REM Go through all the arguments (or files dropped into this batch script)
FOR %%G IN (%*) DO (
	REM - "dp" means "Drive Path".
	SET _mapname=%%~nxG
	SET _tempbsp="%%~dpG%_OUTFOLDER%\!_mapname!"

	REM - Hey, shut up about copying files, ill pipe the output to nul
	COPY %%G %_destfolder% > nul
	
	REM - Before we extract, decompression is required
	ECHO ^> Decompressing %%~nxG..
	%_BSPZIP% -game "%~0/../.." -repack !_tempbsp!
	echo/
	
	REM - We don't want duplicate entity lmp files with numbers after 0!!
	REM - SO GO KILL THEM
	SET _lmp0="%%~dpG%_OUTFOLDER%\%%~nG_l_0.lmp"
	IF EXIST !_lmp0! (
		DEL /Q !_lmp0!
	)
	ECHO ^> Extracting the entity lump from %%~nxG..
	%_VBSPINFO% -x0 !_tempbsp!
	echo/
	
	REM - ugh, backslashes are enforced for this command and not copy?
	REM - - "nx" means "Name eXtension"
	DEL /Q !_tempbsp!
	ECHO ^>^> DONE.
	echo/
)

ECHO ^>^> Well, I reckon that's that
timeout /t 10